package client_anonym

import (
	"os"
	"testing"

	"git.p78su.freemyip.com/svi/gostore/pkg/mock"
	"git.p78su.freemyip.com/svi/gostore/pkg/types"
)

const (
	strUrl = "http://localhost:25000/"
)

type tester struct {
	t      *testing.T
	serv   types.IService
	client *ClientAnonym
}

func TestClientAnonym(t *testing.T) {
	fnClear := func() {
		_ = os.RemoveAll("./store")
	}
	fnClear()
	defer fnClear()
	sf := &tester{
		t: t,
	}
	sf.create()
}

// Создание клиента
func (sf *tester) create() {
	sf.t.Log("create")
	sf.createBad1()
	sf.createBad2()
	sf.createGood1()
}

func (sf *tester) createGood1() {
	sf.t.Log("createGood1")
	var err error
	sf.client, err = NewClientAnonym(sf.serv, strUrl)
	if err != nil {
		sf.t.Fatalf("createGood1(): err=\n\t%v", err)
	}
	if sf.client == nil {
		sf.t.Fatalf("createGood1(): client==nil")
	}
}

// Нет адреса хранилища
func (sf *tester) createBad2() {
	sf.t.Log("createBad2")
	var err error
	sf.serv, err = mock.MakeMock()
	if err != nil {
		sf.t.Fatalf("createBad2(): err=\n\t%v", err)
	}
	client, err := NewClientAnonym(sf.serv, "")
	if err == nil {
		sf.t.Fatalf("createBad2(): err==nil")
	}
	if client != nil {
		sf.t.Fatalf("createBad2(): client!=nil")
	}
}

// Нет объекта сервиса
func (sf *tester) createBad1() {
	sf.t.Log("createBad1")
	client, err := NewClientAnonym(nil, strUrl)
	if err == nil {
		sf.t.Fatalf("createBad1(): err==nil")
	}
	if client != nil {
		sf.t.Fatalf("createBad1(): client!=nil")
	}
}
